package net.wanji.com.common.enums;

import lombok.Getter;
import org.apache.commons.lang3.StringUtils;

/**
 * @author duanruiming
 * @date 2023/05/08 10:17
 */
@Getter
public enum CommandResultSign {

    HEARTBEAT("55ab", "heartBeatService"),
    GET_DEVICE_INFO("2001", "getDeviceInfoService"),
    GET_SIGNAL_BASE_INFO("2002","getBaseInfoService"),
    GET_LIGHTS_GROUP_INFO("2003", "getLightsGroupInfoService"),
    GET_PHASE_INFO("2004", "getPhaseInfoService"),
    GET_DETECTOR_INFO("2005", "getDetectorInfoService"),
    GET_STAGE_INFO("2006", "getStageInfoService"),
    GET_PHASE_SECURITY_INFO("2007", "getPhaseSecurityInfoService"),
    GET_SCHEME_INFO("2009", "getSchemeInfoService"),
    GET_DAILY_PLAN_INFO("2011", "getDailyPlanInfoService"),
    GET_SCHEDULES_INFO("2012", "getSchedulesInfoService"),
    GET_RUNNING_STATE_INFO("2013", "getRunningStateInfoService"),
    GET_TRAFFIC_DATA_INFO("2014", "getTrafficDataInfoService"),
    GET_ALARM_INFO("2015", "getAlarmInfoService"),
    GET_FAULT_INFO("2016", "getFaultInfoService"),

    SET_DEVICE_INFO("3001", "setDeviceInfoService"),
    SET_SIGNAL_BASE_INFO("3002","setBaseInfoService"),
    SET_LIGHTS_GROUP_INFO("3003", "setLightsGroupInfoService"),
    SET_PHASE_INFO("3004", "setPhaseInfoService"),
    SET_DETECTOR_INFO("3005", "setDetectorInfoService"),
    SET_STAGE_INFO("3006", "setStageInfoService"),
    SET_PHASE_SECURITY_INFO("3007", "setPhaseSecurityInfoService"),
    SET_SCHEME_INFO("3009", "setSchemeInfoService"),
    SET_DAILY_PLAN_INFO("3011", "setDailyPlanInfoService"),
    SET_SCHEDULES_INFO("3012", "setSchedulesInfoService"),
    SET_TRAFFIC_DATA_INFO("3014", "setTrafficDataInfoService"),
    SET_ALARM_INFO("3015", "setAlarmInfoService"),
    SET_FAULT_INFO("3016", "setFaultInfoService"),
    SET_CONTROL_INFO("4017", "setControlInfoService");


    private String hexSign;
    private String className;

    CommandResultSign(String hexSign, String className) {
        this.hexSign = hexSign;
        this.className = className;
    }

    public static String getClassNameByHexSign(String hexSign) {
        if (StringUtils.isEmpty(hexSign)) {
            return null;
        }
        for (CommandResultSign uniqueCommandResultSign : values()) {
            if (uniqueCommandResultSign.hexSign.equals(hexSign)) {
                return uniqueCommandResultSign.className;
            }
        }
        return null;
    }
}
